﻿<?php
///////////////////////////////////////////////////////////////////////////
require_once 'lib/abstract_preloaded_regular_screen.php';
require_once 'lib/abstract_controls_screen.php';

///////////////////////////////////////////////////////////////////////////

class DemoSetupScreen extends AbstractControlsScreen
{
    const ID = 'setup';

    ///////////////////////////////////////////////////////////////////////

    public function __construct()
    {
        parent::__construct(self::ID);
    }
	public static function get_media_url_str()
    {
        return MediaURL::encode(array('screen_id' => self::ID));
    }
    public function do_get_control_defs(&$plugin_cookies)
    {
        $defs = array();

        $show_tv = isset($plugin_cookies->show_tv) ?
            $plugin_cookies->show_tv : 'yes';
        
		$bg_path = DuneSystem::$properties['data_dir_path'].'/bg_path';
		if (file_exists($bg_path))
			$b_ground = file_get_contents($bg_path);
		else
			$b_ground = 'yes';
		
		$mode_path = DuneSystem::$properties['data_dir_path'].'/mode_path';
		if (file_exists($mode_path))
			$mode_ground = file_get_contents($mode_path);
		else
			$mode_ground = 'mosaic';
		
        $show_ops = array();
        $show_ops['yes'] = '%tr%yes';
        $show_ops['no'] = '%tr%no';
		
		$mode_ops = array();
        $mode_ops['mosaic-mode'] = 'mosaic';
        $mode_ops['compact-mode'] = 'compact';
		
		$ver = file_get_contents(dirname(__FILE__).'/dune_plugin.xml');
		if (is_null($ver)) {
				hd_print('Can`t load dune_plugin.xml');
				return 'n/a';
			}
		$xml = HD::parse_xml_document($ver);
		$plugin_version = strval($xml->version);
		$plugin_caption = strval($xml->caption);
		$plugin_name = strval($xml->name);
		$this->add_label($defs,"$plugin_caption:",$plugin_version);
        
		$this->add_combobox($defs,
            'show_tv', '%tr%show_tv_main',
            $show_tv, $show_ops, 0, true);
		
		$this->add_combobox($defs,
            'b_ground', '%tr%b_grounds',
            $b_ground, $show_ops, 0, true);
		$this->add_label($defs,'','%tr%ip_ac_inf');
		$path = "http://" . HD::get_ip_address() . "/cgi-bin/plugins/$plugin_name/do";
		$this->add_label($defs,'%tr%ip_access',$path);
		
		$this->add_combobox($defs,
            'mode_ground', '%tr%mode_grounds',
            $mode_ground, $mode_ops, 0, true);

        return $defs;
    }

    public function get_control_defs(MediaURL $media_url, &$plugin_cookies)
    {
        return $this->do_get_control_defs($plugin_cookies);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        
        foreach ($user_input as $key => $value)

        if ($user_input->action_type === 'confirm')
        {
            $control_id = $user_input->control_id;
            $new_value = $user_input->{$control_id};

            if ($control_id === 'show_tv')
                $plugin_cookies->show_tv = $new_value;
			if ($control_id === 'b_ground')
			 { 
				$data_path = DuneSystem::$properties['data_dir_path'].'/bg_path';
				$data = fopen($data_path,"w");
				if (!$data)
				return ActionFactory::show_title_dialog("Err bg_path!!!");
				fwrite($data, $new_value);
				@fclose($data);
				return ActionFactory::show_title_dialog("%tr%save_bg_path");
			 }
			if ($control_id === 'mode_ground')
			 { 
				$data_path = DuneSystem::$properties['data_dir_path'].'/mode_path';
				$data = fopen($data_path,"w");
				if (!$data)
				return ActionFactory::show_title_dialog("Err bg_path!!!");
				fwrite($data, $new_value);
				@fclose($data);
				return ActionFactory::show_title_dialog("%tr%save_mode_path");
			 }
                

        }

        return ActionFactory::reset_controls(
            $this->do_get_control_defs($plugin_cookies));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
