﻿<?php


require_once 'lib/hashed_array.php';
require_once 'lib/tv/abstract_tv.php';
require_once 'lib/tv/default_epg_item.php';

require_once 'surface_channel.php';



class SurfaceM3uTv extends AbstractTv
{
    public function __construct()
    {
        parent::__construct(
            AbstractTv::MODE_CHANNELS_N_TO_M,
            Config::TV_FAVORITES_SUPPORTED,
			false);
    }

    public function get_fav_icon_url()
    {
        return Config::FAV_CHANNEL_GROUP_ICON_PATH;
    }
	public function get_tv_stream_url($playback_url, &$plugin_cookies)
    {
	$page = HD::http_get_document("http://www.rmfon.pl/stacje/flash_aac_".$playback_url.".xml.txt");
	$xml = simplexml_load_string($page);		
	$urls = (array) $xml->playlist->item;
	foreach($urls as $url){
	ini_set('default_socket_timeout', '1');
	$fp = fopen($url, "r");
	$res = fread($fp, 500);
	fclose($fp);
	if (strlen($res) > 0) 
	return $url;
	}
	}
    protected function load_channels(&$plugin_cookies)
    {
        $this->channels = new HashedArray();
        $this->groups = new HashedArray();

		$default_group = new DefaultGroup(
		$id = '__all_channels', 
		$title = Config::ALL_CHANNEL_GROUP_CAPTION, 
		$icon_url = Config::ALL_CHANNEL_GROUP_ICON_PATH
		);
		$doc = HD::http_get_document('http://www.rmfon.pl/xml/stations.txt');
		if (is_null($doc))
            throw new Exception('Can not fetch playlist');
     
        $xml = simplexml_load_string($doc);

        if ($xml === false)
        {
            hd_print("Error: can not parse XML document.");
            hd_print("XML-text: $doc.");
            throw new Exception('Illegal XML document');
        }
		$i=0;
		foreach ($xml->station as $station)
        {

            $channel =
                new SurfaceChannel(
                    $i,
					strval($station['name']),
					strval($station['link']),
					strval('plugin_file://www/lib/logo/logo.png'),
					strval($station['id']),
                    $i+1,
                    $past_epg_days = 0, 
					$future_epg_days = 10,
                    $epg_url = false);

			$channel->add_group($default_group);
        	$this->channels->put($channel);
        	$default_group->add_channel($channel);
            $i++;
        }
				
		$this->groups->put($default_group);
    }
	public function get_tv_playback_url($channel_id, $archive_ts, $protect_code, &$plugin_cookies)
    {
		$url = $this->get_channel($channel_id)->get_streaming_url();
        return $url;
    }
    public function get_day_epg_iterator($channel_id, $day_start_ts, &$plugin_cookies)
    {	
		$url = $this->get_channel($channel_id)->get_streaming_url();
		$doc = HD::http_get_document("http://www.rmfon.pl/stacje/playlista_".$url.".json.txt");
		if (is_null($doc))
            throw new Exception('Can not fetch epg');
        $di_object = @json_decode ($doc);
        foreach ($di_object as $value) {
	    $desc = self::clean_up ($value->recordTitle . " (" .$value->year . ")");
	    $name = self::clean_up ($value->author . " - " .$value->title);
		$last_time = $value->timestamp;
	    $epg[$last_time]["name"] = $name;
	    $epg[$last_time]["desc"] = $desc;
		$qq = $last_time + ($value->lenght);
	    }

	$epg_result = array();
	ksort($epg, SORT_NUMERIC);
	foreach ($epg as $time => $value) {
		$tt[] = $time;
	    $epg_result[] =
                new DefaultEpgItem(
                    strval($value["name"]),
                    strval($value["desc"]),
                    intval($time),
                    intval(-1));
	}
	return
            new EpgIterator(
                $epg_result,
                $tt[0],
                $qq);
    }
    

    
	public function get_group($group_id=null)
    {
        $g = $this->groups->get($this->get_all_channel_group_id());
		
        if (is_null($g))
            throw new Exception("Unknown group: $group_id");

        return $g;
    }
    
    private function clean_up($string)
    {
        $string = stripcslashes($string);
        $string = strip_tags($string);
        $string = str_replace('""', '"', $string);
        $string = str_replace("''", "'", $string);
		$string = str_replace("&amp;", "&", $string);
        return $string;
    }
}
?>